<?php
//===================================================================================
///                                                    Fichier : classeDebug.php
///===================================================================================
// Ce fichier ne sera charg qu'une fois
if (defined("CLASSE_DEBUG_PHP")) return;
define("CLASSE_DEBUG_PHP", "1");
//====================================================================================
///
///	CLASS  DEBUG
	CLASS  DEBUG {
///
///	Usage:    $D = new DEBUG('window_name', 'path/to/debug_directory');
///			      $D->show($var,'name_of_var');
///           $D->close();
///
///			Second parameter is optional (used as label)
///
///	(c) by DATABAY AG 2001 - ay@databay.de
///
///====================================================================================
///  function DEBUG($fenetre='', $repDebug='./Debug') {
  function DEBUG($fenetre='', $repDebug='./Debug') {
///====================================================================================
/// Init trace des variables PHP

  	if(empty($fenetre)) $fenetre = 'DEBUG';
  	$this->fenetre = $fenetre;

  	$ficDebug="$repDebug/traceDebug.html";
  	$this->traceDebugFileName = $ficDebug;

  	$dat = date("d/m/Y").' '.date("H:i:s");
  	$datHtml = ereg_replace(' ', '&nbsp;', $dat);

  	@touch($this->traceDebugFileName);
   	if(!file_exists($this->traceDebugFileName)) {
     	$this->traceDebugFileName = ereg_replace('^\.\./', '', $ficDebug);
    	@touch($this->traceDebugFileName);
   	}

  	$D = "<TABLE SIZE=100% CELLSPACING=0 CELLPADDING=0 BORDER=0><TR><TD><HR SIZE=1></TD><TD WIDTH=1%><FONT FACE='Verdana,arial' SIZE=1>$datHtml</FONT></TD></TR></TABLE>";
  	$this->traceDebug = @fopen($this->traceDebugFileName,"w");    // Raz the file
  	if (empty($this->traceDebug)) {
  	  if(empty($this->alertDebugDone)) {
    		$this->alertDebugDone = 1;
    		?>
    		<SCRIPT>
    		  alert("DEBUG needs a file at '<?echo $this->traceDebugFileName;?>' to write the debug-information into.\n"+
    		        "Please create this file and give it write access.");
    		</SCRIPT>
    		<?
      }
  	} else {
  		@fwrite($this->traceDebug,$D."\n"); // Write date
  		@fclose($this->traceDebug);         // Next traces will be appended
  	  $this->traceDebug = @fopen($this->traceDebugFileName,"a");    // Open file in "append" mode
  	} // Fin if (empty($this->traceDebug)) ... else ...

  } // End of function DEBUG()

///
///====================================================================================
///  function writeDebugOnTop($D) {
  function writeDebugOnTop($D) {
///====================================================================================
///
  	$alt = @file($this->traceDebugFileName);// Read content of file; $alt = array of lines
  	$alt[] = "";                      // Last line empty
  	$alt = implode($alt,"");          // Concatenate the lines

  	$this->traceDebug = @fopen($this->traceDebugFileName,"w");
  	if (!empty($this->traceDebug)) {
  		@fwrite($this->traceDebug,$D."\n"); // Write trace
  		@fwrite($this->traceDebug,$alt);    // Add previous content
  	} // Fin if (empty($this->traceDebug))

  } // End of function writeDebugOnTop($D)

///
///====================================================================================
///  function writeDebug($D) {
  function writeDebug($D) {
///====================================================================================
/// Fonctionnalit "on top" trs couteuse
/// => le fichier est ouvert en mode "append", et la trace y est ajoute  la fin
///
  	if (!empty($this->traceDebug)) {
  		@fwrite($this->traceDebug,$D."\n"); // Write trace
  	} // Fin if (empty($this->traceDebug))

  } // End of function writeDebug($D)

///
///====================================================================================
///  function dspVar($V,$Name="") {
  function dspVar($V,$Name="") {
///====================================================================================

  	$TYPE_COLOR  = "RED";
  	$NAME_COLOR  = "BLUE";
  	$VALUE_COLOR = "BLACK";

  	$dsp = 0;
  	$D = "";

  	if (is_int($V)) { $dsp = 1;

  		$D = "<FONT COLOR=$TYPE_COLOR><B>Integer: </B></FONT>";
  		if ($Name!="") { $D .= "&#40; <FONT COLOR=$NAME_COLOR>$Name</FONT> &#41; "; }
  		$D .= " &#91; <FONT COLOR=$VALUE_COLOR>$V</FONT> &#93;";
  	}
  	if (is_double($V)) { $dsp = 1;
  		$D = "<FONT COLOR=$TYPE_COLOR><B>Double: </B></FONT>";
  		if ($Name!="") { $D .= "&#40; <FONT COLOR=$NAME_COLOR>$Name</FONT> &#41; "; }
  		$D .= " &#91; <FONT COLOR=$VALUE_COLOR>".number_format($V,2,',',' ')."</FONT> &#93;";
  	}
  	if (is_string($V)) { $dsp = 1;
  	  $V = htmlEntities($V);
  		$D = "<FONT COLOR=$TYPE_COLOR><B>String: </B></FONT>";
  		if ($Name!="") { $D .= "&#40; <FONT COLOR=$NAME_COLOR>$Name</FONT> &#41; "; }
  		$D .= " &#91; <FONT COLOR=$VALUE_COLOR>&quot;$V&quot;</FONT> &#93;";
  	}
  	if (is_array($V)) { $dsp = 1;

  		$D = "<FONT COLOR=$TYPE_COLOR><B>Array: </B></FONT>";
  		if ($Name!="") { $D .= "&#40; <FONT COLOR=$NAME_COLOR>$Name</FONT> &#41; "; }
  		$D .= "<FONT COLOR=$VALUE_COLOR><UL>";

  		while(list($key, $val) = each($V)) {
  			$D .= $this->dspVar($val,$key);     // Call again display function
  		}
  		$D .= "</UL></FONT>";
  	}
  	if (is_object($V)) { $dsp = 1;

  		$D = "<FONT COLOR=$TYPE_COLOR><B>Object: </B></FONT>";
  		if ($Name!="") { $D .= "&#40; <FONT COLOR=$NAME_COLOR>$Name</FONT> &#41; "; }
  		$D .= "<FONT COLOR=$VALUE_COLOR><UL>";

  		$V = get_object_vars($V);
  		while(list($key, $val) = each($V)) {
  			$D .= $this->dspVar($val,$key);     // Call again display function
  		}
  		$D .= "</UL></FONT>";
  	}

  	if(!$dsp) { // On n'a encore rien affich !
    	$V = htmlEntities($V);
  		$D = "<FONT COLOR=$TYPE_COLOR><B>??? : </B></FONT>";
  		if ($Name!="") { $D .= "&#40; <FONT COLOR=$NAME_COLOR>$Name</FONT> &#41; "; }
  		$D .= " &#91; <FONT COLOR=$VALUE_COLOR>$V</FONT> &#93;";
  	}

  	$D .= "<BR>";
  	return($D);

  } // End of function dspVar($V,$Name="")

///
///====================================================================================
///  function show($V,$Name="") {
  function show($V,$Name="") {
///====================================================================================

  	$D = $this->dspVar($V,$Name);
/// Add line delimiter and date
//	$D .= "<TABLE SIZE=100% CELLSPACING=0 CELLPADDING=0 BORDER=0><TR><TD><HR SIZE=1></TD><TD WIDTH=1%><FONT FACE='Verdana,arial' SIZE=1>".date("d.m.Y")."&nbsp;".date("H:i:s")."</FONT></TD></TR></TABLE>";

    $this->writeDebug( $D );

  } // End of function show($V,$Name="")

///
///====================================================================================
///  function close() {
  function close() {
///====================================================================================

    @fclose($this->traceDebug);
    unset($this->traceDebug);

/// Open debug window
  	?>
  	<SCRIPT>
  		w=window.open("<?echo $this->traceDebugFileName;?>","<?echo $this->fenetre;?>","WIDTH=450,HEIGHT=500,menubar=yes,scrollbars=yes,resizable=yes");
  		w.focus();
  	</SCRIPT>
  	<?

  } // End of function close();

///
///====================================================================================
///  function traceParametres() {
  function traceParametres($proc='?') {
///====================================================================================
///
/// Affichage des paramtres reus via HTTP_POST et HTTP_GET
///
///====================================================================================

    $this->show('', "--- Paramtres reus par $proc");

    foreach($GLOBALS['HTTP_POST_VARS'] as $nom => $val) {
//      echo "<br>$nom=$val";
      $this->show($val, $nom);
    }
    foreach($GLOBALS['HTTP_GET_VARS'] as $nom => $val) {
//      echo "<br>$nom=$val";
      $this->show($val, $nom);
    }
    foreach($GLOBALS['HTTP_POST_FILES'] as $nom => $val) {
//      echo "<br>$nom=$val";
      $this->show($val, $nom);
    }

    $this->show('', "--- Fin paramtres reus par $proc");
    $this->show('', '');

  } // Fin function traceParametres($proc='?')

//====================================================================================
} // End of class DEBUG
//====================================================================================
?>