<?php
//===================================================================================
///                                                    Fichier : mes_fonctions.php
///===================================================================================
///
/// Renseigner les paramtres spcifiques  l'appli
///
  include('Tools/paramsAppli.php');

//====================================================================================
// Les fonctions ci-dessous ne doivent tre dfinies qu'une fois
if (defined("_MES_FONCTIONS_")) return;
  define("_MES_FONCTIONS_", "1");

//====================================================================================
///
///   Paramtres de mise en page modifis dans SPIP
///
//====================================================================================
/// Modifications mise en page Spip
///    => 'debut_intertitre' : filets mauves + classe "h3Spip" pour le texte
///    => 'fin_intertitre'   : fin classe "h3Spip"
///    => 'puce' : aligner la puce sur la ligne de base du texte

  $GLOBALS['debut_intertitre'] =
                  "<br><span class=\"h3Spip\">";
  $GLOBALS['fin_intertitre'] =
                  "</span><br>&nbsp;<br>";
	$GLOBALS['puce'] =
	                "<img src='puce.gif' align='bottom' alt='- ' border='0'>";

///====================================================================================
///====================================================================================
///
/// Fonctions utilitaires de l'appli
///
///====================================================================================
///   Tronquer un texte
///
///   Retourne un tableau
///      table[0] = texte tronqu (en fin de mot et hors balise html)
///      table[1] = ce qui a t supprim
///
//====================================================================================
///   function tronquerTexte(&$texte, $maxTexte=0) {
   function tronquerTexte(&$texte, $maxTexte=0) {

///  => Tronquer
      if($maxTexte && strlen($texte)>$maxTexte) {
        $texte1 = substr($texte, 0, $maxTexte);

///  => Rechercher le dernier sparateur...
        $i = 0;
        foreach(array(' ', '&nbsp;', ',', '.', ';', "\n") as $sep) {
          if($j=strrpos($texte1, $sep)) $i = max($i,$j);
        }

///     ... et tronquer le texte
        if($i) $texte1 = substr($texte1, 0, $i);

///  => Ne pas couper  l'intrieur d'une balise HTML (cf. mise en page Spip)
        $i = strrpos($texte1,'<');
        $j = strrpos($texte1,'>');
        if($i>0 && (!$j || $j<$i)) $texte1 = substr($texte1, 0, $i);
        $i = strlen($texte1);

///  => Rechercher le dernier retour  la ligne dans la dernire ligne (50 car.)
        $i0 = max(0, $i - 50);
        $i  = $i0;
        foreach(array('<br>', '<br />', '<p>', '<p ', '<BR>', '<BR />', '<P>', '<P ') as $sep) {
          if($j=strrpos($texte1, $sep)) $i = max($j,$i);
        }

///     ... et tronquer le texte again
        if($i != $i0) $texte1 = substr($texte1, 0, $i);

///  => Traiter le cas d'un double retour  la ligne
        $texte1 = eregi_replace("<br[ /]*>[ \n]*$", '', $texte1);
        $texte1 = eregi_replace("<p>[ \n]*$", '', $texte1);

///  => Supprimer les espaces en fin de chaine
        $texte1 = eregi_replace("[ \n]*$", '', $texte1);

///  => Rcuprer la partie tronque
        $texte2 = substr($texte, strlen($texte1));

      } else {
        $texte1 = $texte;
        $texte2 = '';
      }

      return array($texte1,$texte2);
   }
///
///====================================================================================
///   Lien vers l'aide Spip (raccourcis typo)
//====================================================================================
///   function lienAideTypoSpip($color) {
   function lienAideTypoSpip($color) {
      return  "<A HREF=\"javascript:window.open('aideTypoSpip.php3', 'aide_spip', 'scrollbars=yes,resizable=yes,width=740,height=580'); void(0);\">".
              "<IMG SRC='icones/aide$color.gif' BORDER='0' ALIGN='MIDDLE'>".
              "</A>";
   }
///
///====================================================================================
///   Remplacement des espaces par '&nbsp;'
//====================================================================================
///    function noSpace($data) { global $debugAppli;
    function noSpace($data) { global $debugAppli;

//      return ereg_replace("[ \n]", '&nbsp;', $data);
      return str_replace(" ", '&nbsp;', $data);
    }
///
///====================================================================================
///   Suppression des numros en dbut de texte
///   NB: Le n doit tre suivi d'une virgule ou d'un point, et d'un espace
//====================================================================================
///    function noNumero($data) { global $debugAppli;
    function noNumero($data) { global $debugAppli;

      return ereg_replace('^[0-9]+[,.] *', '', $data);
    }
///
///====================================================================================
///   Suppression de la mise en page
///     effectue par le filtre "propre()"
//====================================================================================
///    function noPropre($data) { global $debugAppli;
    function noPropre($data) { global $debugAppli;

      $data = str_replace('&lt;', '<', $data);
      $data = eregi_replace('<BR[ /]*>', '', $data);
      $data = eregi_replace("<[/]*p[^>]*>", '', $data);
      return $data;
    }
///
///====================================================================================
///   Afficher les retours  la ligne
///   Usage : [(#TEXTE*|CrLfToBr|propre)]
//====================================================================================
///    function CrLfToBr($data) { global $debugAppli;
    function CrLfToBr($data) { global $debugAppli;

      $data = nl2br($data);
      $data = eregi_replace("<br /> *\n* *<br />", "<br />&nbsp;<br />", $data);
      return $data;
    }
///
//====================================================================================
    function trace($data) {
//====================================================================================

       echo "<hr>";
       echo "\n<p>".str_replace(' ',  '+',
                    str_replace("\n", 'NL',
                    htmlEntities($data)))."</p>\n";
       return $data;
    }
///
///====================================================================================
///   Convertir une date anglaise (jour et l'heure) en date franaise (sans l'heure)
//====================================================================================
///    function dateEnToFr($data) { global $debugAppli;
    function dateEnToFr($data) { global $debugAppli;

      return ereg_replace('^([0-9]*)-([0-9]*)-([0-9]*) *.*$', '\3/\2/\1', $data);
    }
///
///====================================================================================
///   Convertir une date franaise (sans l'heure) en date anglaise (jour et l'heure)
//====================================================================================
///    function dateFrToEn($data) { global $debugAppli;
    function dateFrToEn($data) { global $debugAppli;

      return ereg_replace('^([0-9]*)/([0-9]*)/([0-9]*) *.*$', '\3-\2-\1 '.date('H:i:s'), $data);
    }
///
///====================================================================================
///   Renseigner les liens de navigation parmi une liste d'objets (messages, brves, ...)
//====================================================================================
///  function setListLinks($nomDebut, $debut, $nbParPage, $nomTotal, $nbTotal, $extra='')
///     $nomDebut     : Nom de la variable "debut" (paramtre de l'url)
///     $debut        : N du premier objet (paramtre de l'url)
///     $nbParPage    : Nb d'objets lists par page
///     $nomTotal     : Nom de la variable "nbTotal" (paramtre de l'url)
///     $nbTotal      : Nb total d'objets
///     $extra        : Chaine  ajouter  l'url
///
  function setListLinks($nomDebut, $debut, $nbParPage, $nomTotal, $nbTotal, $extra='') { global $debugAppli;

    $url     = explode('?', $_SERVER['REQUEST_URI']);
    $urlPage = $url[0];
    $params  = $url[1];
    $params  = ereg_replace("&*$nomDebut=[0-9]*",'',$params);
    $params  = ereg_replace("&*$nomTotal=[0-9]*",'',$params);
    $params  = ereg_replace("&*recalcul=oui",'',$params);
    if($extra) $extra = '&'.$extra;

    $urlPage .= '?'.$params.$extra.'&recalcul=oui'; // Besoin de recalculer (cf. $debut_liste ?!?)

    $k = 1;
    $lnks = array();
    for($i=0; $i<$nbTotal; $i+=$nbParPage) {
      if($i==$debut) {
        $lnks[] = "&nbsp;<B>[$k]</B>&nbsp;";
      } else {
        $lnks[] = "<A HREF='$urlPage&$nomDebut=$i&$nomTotal=$nbTotal'>&nbsp;[$k]&nbsp;</A>";
      }
      $k++;
    } // Fin for($i=0; $i<$nbTotal; $i+=$nbParPage)

    return $lnks;

  } // Fin function setListLinks($nomDebut, $debut, $nbParPage, $nomTotal, $nbTotal, $extra='')


///
///====================================================================================
//====================================================================================
///   Fonctions spcifiques  l'appli : fichier "mes_fonctionsAppli.php"
///====================================================================================
///
    if(is_file('mes_fonctionsAppli.php')) include 'mes_fonctionsAppli.php';
///
///====================================================================================
// Fin du fichier mes_fonctions.php
?>