<?php
//===================================================================================
///                                                 Fichier : mes_fonctionsAppli.php
///===================================================================================
///
/// Complment  mes_fonctions.php3 : Dclarations et fonctions spcifiques  l'appli
///
//====================================================================================
//global $debugAppli;
//include "Tools/classeDebug.php";
//if(!$debugAppli) $debugAppli = new DEBUG;

//====================================================================================
// Ce fichier ne sera charg et excut qu'une fois (cf. defMenu.html)
if (defined("_MES_FONCTIONS_APPLI")) return;
define("_MES_FONCTIONS_APPLI", "1");

  	if(is_file('ecrire/inc_connect.php3')) {
  	  include 'ecrire/inc_import.php3';
  	  include 'ecrire/inc_meta.php3';
  	} else {
  	  include 'ecrire/inc_import.php';
  	  include 'ecrire/inc_meta.php';
  	}

///====================================================================================
///====================================================================================
///
/// Fonctions utilitaires de l'appli
///
///====================================================================================
///   Renseigner xml_ParamsObjetSpip
//====================================================================================
///    function set_ParamsObjetSpip($data, $nomId) { global $debugAppli;
    function set_ParamsObjetSpip($data, $nomId) { global $debugAppli;
      global $xml_ParamsObjetSpip;

      if(ereg('^[0-9]+,.*$', $data)) {
        $id = ereg_replace('^([0-9]+),.*$', '\1', $data);
        $xml_ParamsObjetSpip = ereg_replace("$nomId=[0-9]*", "$nomId=$id", $xml_ParamsObjetSpip);
      }
      return;
    }
///
///====================================================================================
///   Renseigner xml_ParamsObjetSpip : id_secteur
//====================================================================================
///    function set_ParamsObjetSpip_id_secteur($data) { global $debugAppli;
    function set_ParamsObjetSpip_id_secteur($data) { global $debugAppli;

      set_ParamsObjetSpip($data, 'id_secteur');
      return $data;
    }
///
///====================================================================================
///   Renseigner xml_ParamsObjetSpip : id_rubrique
//====================================================================================
///    function set_ParamsObjetSpip_id_rubrique($data) { global $debugAppli;
    function set_ParamsObjetSpip_id_rubrique($data) { global $debugAppli;

      set_ParamsObjetSpip($data, 'id_rubrique');
      return $data;
    }
///
///====================================================================================
///   Renseigner xml_ParamsObjetSpip : id_parent
//====================================================================================
///    function set_ParamsObjetSpip_id_parent($data) { global $debugAppli;
    function set_ParamsObjetSpip_id_parent($data) { global $debugAppli;

      set_ParamsObjetSpip($data, 'id_parent');
      return $data;
    }
///
///====================================================================================
///   Renseigner xml_ParamsObjetSpip : id_article
//====================================================================================
///    function set_ParamsObjetSpip_id_article($data) { global $debugAppli;
    function set_ParamsObjetSpip_id_article($data) { global $debugAppli;

      set_ParamsObjetSpip($data, 'id_article');
      return $data;
    }
///
///====================================================================================
///   Renseigner xml_ParamsObjetSpip : id_rubrique et id_secteur
//====================================================================================
///    function set_ParamsObjetSpip_id_rubrique_id_secteur($data) { global $debugAppli;
    function set_ParamsObjetSpip_id_rubrique_id_secteur($data) { global $debugAppli;

      set_ParamsObjetSpip_id_rubrique($data);
      set_ParamsObjetSpip_id_secteur(ereg_replace('^[0-9]*,(.*)$', '\1', $data));
      return $data;
    }
///
///====================================================================================
///   Supprimer les champs "id" dans la valeur d'un champ de type "select"
//====================================================================================
///    function noId_xxx($balise) { global $debugAppli;
    function noId_xxx($balise) { global $debugAppli;
      global $attributs;

      $data = $attributs[$balise];
      while(ereg('^[0-9]+,.*$', $data)) $data = ereg_replace('^[0-9]+,(.*)$', '\1', $data);
      return $data;
    }

///
//====================================================================================
///
///   Traitement Xml : Filtres "avant import"
///
///====================================================================================
///  function useImportSuffix($balise)
///     $balise : balise en cours de traitement
///
///     $attributsModele[$balise] contient la valeur des attributs de la balise en cours
///     $attributs contient l'ensemble des attributs de l'objet en cours
///
//====================================================================================
///
///   Actions
///     Si la balise est renseigne
///       => Changer l'importation de l'objet en cours.
///       => Pour ce faire, on renseigne l'attribut 'SuffixeImport'
///     Sinon excuter la fonction  "avantImport_Non_<balise>($balise)"
///
//====================================================================================
  function useImportSuffix($balise) { global $debugAppli;
     global $balisesFicheXML, $xml_ProcessXML_Requete, $attributsModele, $attributs;

/// Si la balise est non vide => utiliser le suffixe <balise> pour l'importation
     if(eregi('[a-z0-9]', $attributs[$balise])) {
       $attributs['SuffixeImport'] = $attributsModele[$balise]['Suffixe'];
if($debugAppli) $debugAppli->show($attributsModele[$balise]['Suffixe'], "Renseignement attributs['SuffixeImport']");
     } else {
      if(function_exists("AvantImport_Non_$balise")) {
        eval("avantImport_Non_$balise"."(\$balise)");
if($debugAppli) $debugAppli->show($balise, "Exec avantImport_Non_$balise".'()');
      }
    }

  }
///
///====================================================================================
///
///   Traitement Xml : Filtres "aprs import"
///
///====================================================================================

///====================================================================================
//====================================================================================
///   Filtres pour le traitement du XML
//====================================================================================
///
///====================================================================================
/// Conversion d'une fiche XML en un tableau PHP
///====================================================================================
///
///    function balisesXML($data) { global $debugAppli;
///
///    Filtre pour SPIP : Conversion d'une fiche XML en un tableau PHP
///
/// Paramtres
///   $data     Fiche XML
///
/// Retourne un tableau : tab[balise]=valeur
///
///====================================================================================
///
/// Exemple de fiche XML (contenu d'un article Spip):
///
///    NB: Les ventuelles balises HTML utilises dans les fiches doivent avoir
///        t codes "balise ..." et "/balise" au lieu de "<balise ...>" et "</balise>".
///        Pour l'exemple, cf. la valeur de la balise XML "EmailAuteur" ci-dessous,
///        qui sera rendue via  tab['EmailAuteur']='N.N <N.N@JuniorSolidarite.org>'
///
///    NB: La balise XML "DocumentXML", et ses attributs, ne sont pas exploits par ce filtre.
///
/// <DocumentXML TypeDocXML="FicheDocument" Handler="FicheXML">
///   <Cadre_1_>
///     <NomArticle>Plaquette de prsentation des Clubs Citoyens</NomArticle>
///     <DomaineDocument>4,Rseau Junior Solidarit</DomaineDocument>
///     <DescriptionArticle>Plaquette de prsentation des Clubs Citoyens distribue au Salon de l'Education (Paris, 20 novembre 2002)</DescriptionArticle>
///     <NomUser>plaquette_salon_edu_CC_201102.pdf</NomUser>
///     <CheminFic>Ressources/plaquette_salon_edu_CC_201102.pdf</CheminFic>
///     <TailleFic>425</TailleFic>
///   </Cadre_1_>
///   <Cadre_2_>
///     <NomAuteur>Nathalie N.</NomAuteur>
///     <FonctionAuteur>Responsable du projet "Clubs Citoyens"</FonctionAuteur>
///     <EmailAuteur>N N. N.N@ClubsCitoyens.org</EmailAuteur>
///   </Cadre_2_>
/// </DocumentXML>
///
///====================================================================================
///
/// Exemple d'utilisation dans un squelette : Liste des fiches contenues dans une rubrique
///
///    NB: Interdites dans ce commentaire, les balises PHP prsentes dans le squelette
///        ont t notes : php? (balise ouvrante)  et ?php (balise fermante).
///
///      <TABLE CELLPADDING="2" WIDTH="500" BORDER="0">
///
///          <BOUCLE_RubrArticles(ARTICLES){id_rubrique}{titre_mot=Plaquette}>
/// php?
///            $fiche = balisesXML('[(#TEXTE*|texte_script)]');
/// ?php
///               <TR>
///                  <TD><A HREF='php?=$fiche['CheminFic'];?php'>
///                          <B>php? echo stripSlashes($fiche['NomArticle']);?php</B>
///                       </A></TD>
///                  <TD>[(#DATE|jour)]/[(#DATE|mois)]/[(#DATE|annee)]</TD>
///                  <TD>(php?=$fiche['TailleFic'];?php&nbsp;K)</TD>
///              </TR>
///              <TR>
///                  <TD COLSPAN="3">php?
///                       echo propre( CrLfToBr( stripSlashes($fiche['DescriptionArticle']) ) );
///                                  ?php</TD>
///              </TR>
///              <TR>
///                  <TD COLSPAN="3"><A HREF='mailto:php?=$fiche['EmailAuteur'];?php'>
///                                     php? echo stripSlashes($fiche['NomAuteur']);?php
///                                  </A></TD>
///              </TR>
///
///          </BOUCLE_RubrArticles>
///
///      </TABLE>
///
///====================================================================================
///
    function balisesXML($data) { global $debugAppli;

      $dataIn  = $data;
      $dataOut = array();

      while( ereg('^([^<]*)<([^>]*)>(.*)$', $dataIn, $regs) ) {          // Recherche balise ouvrante
        $dataOK  = 0;
        $balise  = $regs[2];
        $dataIn  = $regs[3];
        $balise  = ereg_replace('^([a-zA-Z0-9_-]*).*$', '\1', $balise);  // Supprimer les attributs
        $dataOut[$balise] = '';

        unset($regs);
        if(ereg("^([^<]*)</$balise *>(.*)\$", $dataIn, $regs)) {         // Texte et balise fermante attendue
          $dataOut[$balise] = codeToHTML($regs[1]);                      // Texte de la dernire balise ouvrante
          $dataIn = $regs[2];
        }

        unset($regs);
        while( ereg('^([^<]*)</([^>]*)>(.*)$', $dataIn, $regs) ) {       // Recherche balises fermantes
          $dataIn = $regs[3];
        }
      unset($regs);
      }

      return $dataOut;

   } // Fin function balisesXML($data)

///
///====================================================================================
///   Encoder une URL
//====================================================================================
///    function encodeUrl($data) { global $debugAppli;
    function encodeUrl($data) { global $debugAppli;

      return 'http://'.urlEncode( str_replace('http://', '', $data) );
    }
///
///====================================================================================
///   Vrifier une URL
//====================================================================================
///    function verifUrl($data) { global $debugAppli;
    function verifUrl($data) { global $debugAppli;

      if(strlen($data)<=strlen('http://')) $data = '';
      $data = ereg_replace('[ "\',;]', '', $data);
      return $data;
    }
///
//====================================================================================
    function codeToHTML($txt) { global $debugAppli;
//====================================================================================

      $val = $txt;


      $val = str_replace('&#8217;', "'", $val);
      $val = str_replace('&#60;',   '<', $val);
      $val = str_replace('NL', "\n", $val);
      $val = ereg_replace('([^]*)', '<\1>', $val);

      $val = str_replace('&#38;',   '&', $val);

      return $val;

    } // Fin function codeToHTML($txt)
///
//====================================================================================
    function HTMLtoCode($txt) { global $debugAppli;
//====================================================================================

      $val = $txt;

      $val = str_replace('&', '&#38;', $val);

      $val = ereg_replace('<([^<>]*)>', '\1', $val);
      $val = str_replace("\n", 'NL', $val);
      $val = str_replace('<', '&#60;', $val);
//      $val = str_replace("'", '&#8217;', $val);

      return $val;

    } // Fin function HTMLtoCode($txt)
///
///====================================================================================
///    function restaurerCodeHTML($tab) { global $debugAppli;
    function restaurerCodeHTML($tab) { global $debugAppli;
///====================================================================================
///
      if(is_array($tab)) {
        $tabHTML = array();
        foreach($tab as $key=>$val) {
          $tabHTML[$key] = codeToHTML($val);
        }

      } else { // Suite if(is_array($tab))
        $tabHTML = codeToHTML($tab);
      } // Fin if(is_array($tab))

      return $tabHTML;

    } // Fin function RestaurerCodeHTML($tab)

///
///====================================================================================
///   Afficher le code XML
//====================================================================================
///    function afficher_xml($data) { global $debugAppli;
    function afficher_xml($data) { global $debugAppli;

      if(strPos($data, "DocumentXML ")) {  // Document XML
        $data = '<xmp>'.$data.'</xmp>';
      } else {
        $data = propre($data);
      }

      return $data;
    }

///
///====================================================================================
/// function majBaseSpip( $nomFichierTmp, &$modeleImport, $dirDebug='Tools/Debug_fiches')
///====================================================================================
///    Mettre  jour la base par "importation" dans Spip
///    Retourne l'id de l'enregistrement cr ou modifi
///====================================================================================

function majBaseSpip( $nomFichierTmp, &$modeleImport, $dirDebug='Tools/Debug_fiches') { global $debugAppli;

    $nomF = $nomFichierTmp.'_'.date('YmdHis');
    $nomFic = $nomF;
    $i = 1;

    while(is_file("$dirDebug/$nomFic")) {
      $nomFic = $nomF."_$i";
      $i++;
    }

    $ficFiche = fopen("$dirDebug/$nomFic", 'w');        // Crer un fichier pour  "import_objet()"
      fwrite($ficFiche,$modeleImport);                  //    (fiche xml  importer)
    fclose($ficFiche);
    unset($ficFiche);

    $ficFiche = fopen("$dirDebug/$nomFic", 'r');

      $new_id = import_objet($ficFiche,'' ,'noPurge');  // Importer l'objet Spip dans la base

    fclose($ficFiche);
    unset($ficFiche);

// Supprimer le fichier import
   if(!$debugAppli && $new_id) unLink("$dirDebug/$nomFic");

    return $new_id;

} // Fin function majBaseSpip( $nomFichierTmp, &$modeleImport, $dirDebug='Tools/Debug_fiches')


///====================================================================================
/// function importObjectIntoSpip($objetAppli, &$attributs, $pathToImportDir='') { global $debugAppli;
 function importObjectIntoSpip($objetAppli, &$attributs, $pathToImportDir='') { global $debugAppli;
///====================================================================================
/// Crer ou mettre  jour l'objet Spip associ  l'objet applicatif
///
/// Paramtres
///   $objetAppli       Objet "applicatif"  crer ou mettre  jour
///                     => Les paramtres d'importation seront trouvs
///                         - dans la variable globale "$import_<ObjetAppli>"
///                         - ou dans le fichier "Tools/Modeles_import/import_<ObjetAppli>_Std.xml"
///   $attributs        Tableau associatif des attributs disponibles
///   $pathToImportDir  Chemin vers les modles d'importation
///
/// Variables globales
///   $userId
///   $errNouvelleFiche
///
/// Retourne
///   true si OK (si KO => cf. $errNouvelleFiche)
///   $attributs      Mis  jour avec les nouveaux id crs
///     En particulier :
///     $attributs['first_objetSpip'] = 'rubrique' ou 'article' ou ...           (objet principal)
///     $attributs['first_id_rubrique'] ou $attributs['first_id_article'] ou ... (objet principal)
///     $attributs['id_rubrique'] ou $attributs['id_article'] ou ...             (objet principal)
///
//====================================================================================
///  global $xml_ProcessXML_Requete, $PathToImportModels;
  global $xml_ProcessXML_Requete, $PathToImportModels;
///====================================================================================
/// Renseigner les id des mots-cls

if($debugAppli) $debugAppli->show($objetAppli, 'importObjectIntoSpip - objetAppli');
if($debugAppli) $debugAppli->show($attributs, 'importObjectIntoSpip - attributs');

    $sql = "SELECT id_mot,id_groupe,titre,type FROM spip_mots ";
    $res = spip_query($sql);
    while( list($id_mot,$id_groupe,$mot,$type_mot)=mysql_fetch_row($res) ) {
      $attributs["id_mot_$mot"]     = $id_mot;
      $attributs["id_groupe_$mot"]  = $id_groupe;
      $attributs["nom_groupe_$mot"] = $type_mot;
    }
    mysql_free_result($res);


//------------------------------------------------------------------------------------
/// Renseigner l'id de l'utilisateur et la date

//------------------------------------------------------------------------------------
// Complter les attributs  utiliser dans l'importation Spip
// NB: Si modification d'une fiche => pas d'auteur (sinon, un lien par modif !

    if($xml_ProcessXML_Requete!='NouvelleFiche') {                        // Modif fiche
      $attributs['idAuteurModif'] = $userId;
      unset($attributs['id_auteur']);                                     // Ne pas ajouter un auteur
    } else {                                                              // Cration fiche
      if(!$attributs['id_auteur']) $attributs['id_auteur'] = $userId;
      if(!$attributs['id_auteur']) $attributs['id_auteur'] = 1;           // webmaster !
    }
    if(!$attributs['Heure'])     $attributs['Heure']     = date('H:i:s'); // 13:57:23
    if(!$attributs['DateJour'])  $attributs['DateJour']  = date('Y-m-d'); // 2002-01-15
    if(!$attributs['Date'])      $attributs['Date']      = $attributs['DateJour'].' '.$attributs['Heure'];
    if(!$attributs['DateRedac']) $attributs['DateRedac'] = $attributs['Date'];
    if(!$attributs['DateFr'])    $attributs['DateFr']    = date('d/m/Y'); // 15/01/2002

//------------------------------------------------------------------------------------
/// Rcuprer les gabarits d'importation :
///    Variable globale "$import_<ObjetAppli>" = 'import_<ObjetSpip>.xml,import_<ObjetSpip>.xml,...'
///    ou bien fichier "import_<ObjetAppli>_Std.xml" (<ObjetAppli> doit alors tre un objet "SPIP")

    $fichier = 'import_'.ucFirst($objetAppli);
    if(!$fichiers=$GLOBALS[$fichier]) $fichiers = $fichier.'_Std.xml';
    $fichiers = explode(',', $fichiers);

    $objetSpip = strToLower( ereg_replace('^import_([^_]+)_.*$', '\1', $fichiers[0]) );

//------------------------------------------------------------------------------------
/// Rechercher les modles d'objets  importer et importer les objets adhoc

/// Le 1er objet doit tre l'objet Spip "principal", i-e celui auquel les autres seront lis.
    $firstIdObjetSpip = 0;
    $id  = $attributs["id_$objetSpip"];
    if(!$dir=$pathToImportDir)
      if(!$dir=$PathToImportModels)
        $dir = 'Tools/Modeles_import';
if($debugAppli) $debugAppli->show($objetSpip,"Group - objetSpip");
if($debugAppli) $debugAppli->show($id,"Group - id_$objetSpip");

    if(!$errNouvelleFiche)
      foreach($fichiers as $nomFic)
        if($nomFic) {

if($debugAppli) $debugAppli->show($nomFic,"Group - nomFic");
          $objetSpip = strToLower( ereg_replace('import_([^_]+)_.*\.xml', '\1', $nomFic) );

          $fic = fopen("$dir/$nomFic", 'r');
            $modeleImport=fread($fic, filesize ("$dir/$nomFic"));
          fclose($fic);

//------------------------------------------------------------------------------------
/// => Placer dans l'objet  importer, les paramtres remplis dans le formulaire
///    (valeurs dans $attributs)

          $textes = explode('%', $modeleImport);
          if(($nb=count($textes))>1) {
            $modeleImport = '';
            for($i=0; $i<$nb; $i+=2) {
              $modeleImport .= $textes[$i];
              $modeleImport .= stripSlashes($attributs[$textes[$i+1]]);
            }
          } // Fin if(count($imports)>1)

/// => Vider les balises restant dans le modle
///    => les attributs associs prendront leur valeur par dfaut
          $modeleImport = ereg_replace('%[^%]*%', '', $modeleImport);
if($debugAppli) $debugAppli->show($modeleImport,'Avant importation - modeleImport');

//------------------------------------------------------------------------------------
/// Importer l'objet dans la base (cration ou modification)

// NB: On rcupre l'id cr dans la base dans  $attributs["id_$objetSpip"]

          $action = 'modifie';
          if($id==0) $action = 'cre';
          $nomTempFic = $objetAppli;

          if( !$attributs["id_$objetSpip"] = majBaseSpip($nomTempFic, $modeleImport) ) {

            $errNouvelleFiche .= "Suite  un problme interne, votre fiche n'a pas pu tre $action dans la base! \\n".
                                 "Veuillez contacter le webmaster... ";
          }

/// Renseigner l'id du nouvel objet Spip cr
          if(!$firstIdObjetSpip) {
            $firstIdObjetSpip = $attributs["id_$objetSpip"]; // Conserver le lien principal...
            $attributs["first_id_$objetSpip"] = $firstIdObjetSpip;
            $attributs["first_objetSpip"]     = $objetSpip;

/// Renseigner si besoin le secteur (si juste cr)
            if(!$attributs['id_secteur'] && $objetSpip=='rubrique') {
              $sql = "UPDATE spip_$objetSpip".'s '.
                     " SET id_secteur=$firstIdObjetSpip ".
                     " WHERE id_$objetSpip=$firstIdObjetSpip ";
              spip_query($sql);
              $attributs['id_secteur']  = $firstIdObjetSpip;
            }
          } // Fin if(!$firstIdObjetSpip)

if($debugAppli) $debugAppli->show($attributs["id_$objetSpip"], "attributs['id_$objetSpip'] aprs majBaseSpip()");
//------------------------------------------------------------------------------------
/// Excuter les ventuels filtres "aprs import"
          if($fct=$attributs['FiltreApresImport']) {
if($debugAppli) $debugAppli->show($fct,"attributs['FiltreApresImport']");
            $filtres    = explode(';', $fct);                                     // Filtres...
            $baliseFcts = explode(';', $attributs['baliseFiltreApresImport']);    // ...et balises associes

            for($j=0; $j<count($filtres); $j++) {
              $filtre = $filtres[$j];
              $balise = $baliseFcts[$j];
if($debugAppli) $debugAppli->show($filtre,'filtre');
if($debugAppli) $debugAppli->show($balise,'balise');

              $fcts = explode(',', $filtre);                    // Filtre
              foreach($fcts as $fct)
                eval( $fct."('$balise', $firstIdObjetSpip);" ); // Excuter chaque filtre
            }
          } // Fin if($fct=$attributs['FiltreApresImport'])

          unset($attributs['FiltreApresImport']);               // N'excuter le filtre qu'une seule fois
          unset($attributs['baliseFiltreApresImport']);

          if($id || $errNouvelleFiche) break;  // $id!=0 => Maj => On ne met  jour que l'objet principal

    } // Fin if(!$errNouvelleFiche) foreach($fichiers as $nomFic) if($nomFic) ...

    return (!$errNouvelleFiche);               // true= OK

  } // Fin  function importObjectIntoSpip($objetAppli, &$attributs)


///====================================================================================
///    function traceBalise($type, $name, &$attributs) { global $debugAppli;
  function traceBalise($type, $name, &$attributs) { global $debugAppli;
///====================================================================================
    global $indentTraceBalise;
///
    switch($type) {
      case 'ouvrante':
        $out = '<BR />';
        if($indentTraceBalise) for($i=0; $i<$indentTraceBalise; $i++) $out .='&nbsp;&nbsp;&nbsp;&nbsp;';
        $indentTraceBalise++;
        $out .= "&lt;$name";
        if(count($attributs))
          foreach($attributs as $nom => $val)
            $out .=" $nom=\"$val\"";
        $out .= '>';
        break;

      case 'fermante':
        $out = "&lt;/$name>";
        $indentTraceBalise--;
        break;

      default:
    }

    return $out;

  } // Fin  function traceBalise($type, $name, &$attributs)


///====================================================================================
/// Filtre processXml : Affichage d'une fiche XML ou du formulaire associ
/// => fichier "fonctionsXml.php"
///====================================================================================
///

    if(is_file('fonctionsXml.php')) include 'fonctionsXml.php';

///====================================================================================
// Fin du fichier mes_fonctionsAppli.php
?>